#define trigPin    5              // Trigger kimenet
#define echoPin    6              // Echo bemenet

int maximumRange = 200;           // Legnagyobb távolság cm-ben
int minimumRange = 1;             // Minimális távolság cm-ben
long duration;                    // Időtartam [us]
float distance;                   // Távolság [cm]

void setup() {
  Serial.begin(115200);           //Soros kapcsolat 9600 bit/s
  Serial.println("Sonar program");
  pinMode(echoPin, INPUT);        //Impulzus bemenet
  pinMode(trigPin, OUTPUT);       //Vezérlő kimenet
  digitalWrite(trigPin, LOW);     //Alaphelyzetben alacsony szint
  pinMode(LED_BUILTIN,OUTPUT);    //A beépített LED jelző funkciót lát el
  digitalWrite(LED_BUILTIN,HIGH);
}

void loop() {
  delay(1000);                       //egy kis várakozás   
  digitalWrite(LED_BUILTIN,HIGH);
  digitalWrite(trigPin, HIGH);
  delayMicroseconds(10);
  digitalWrite(trigPin, LOW);
  duration = pulseIn(echoPin, HIGH); //Impulzus szélességének meghatározása
  digitalWrite(LED_BUILTIN,LOW);
  distance = duration/58.82;         // Kiszámoljuk a távolságot
  if (distance >= maximumRange || distance < minimumRange) {
    distance = -1.0;
  } 
  Serial.print(distance);            // A mért távolság kiíratása
  Serial.println(" cm"); 
}
