#include <NewPing.h>

/* HC-SR04 paraméterek */
#define TRIGGER_PIN  5
#define ECHO_PIN     6
#define MAX_DISTANCE 200

unsigned int pingSpeed = 500;    // Ilyen gyakorisággal mérünk (500 ms)
unsigned long pingTimer;         // Időbélyeg a következő méréshez
volatile long sonar_val = 0;     // A kiolvasott eredmény

NewPing sonar(TRIGGER_PIN, ECHO_PIN, MAX_DISTANCE);

void setup() {
  Serial.begin(115200);
  pingTimer = millis() + 50;     // Ekkor kezdjük a mérést
}

void loop() {
  long reading;
  if (millis() >= pingTimer) {   // Ha elérkezett az idő
    pingTimer += pingSpeed;      // Következő időpont előjegyzése
    sonar.ping_timer(echoCheck); // Mérés indítása, az echoCheck visszahívási függvény regisztrálása
  }
  if (sonar_val) {
    Serial.print("Ping: ");
    Serial.print(sonar_val / US_ROUNDTRIP_CM); // uS result in sonar_val
    Serial.println("cm");
    sonar_val = 0;
  }
}
void echoCheck() {                     // Timer2 megszakításból hívjuk
  if (sonar.check_timer()) {           // Így ellenőrizzük, hogy volt-e már válasz
    sonar_val = sonar.ping_result;     // Eredmény kiolvasása
  }
}
